
#import "BuildaDudeIIDoc.h"
#import "BuildaDudeIIAppController.h"
#import "WW3DWell.h"

@implementation BuildaDudeIIDoc


- init
{
   char buf[MAXPATHLEN + 1];
   id bundle;


   [super init];
   bundle = [NXBundle bundleForClass:[self class]];
   [bundle getPath:buf forResource:"BuildaDudeIIDoc" ofType:"nib"];
   [NXApp loadNibFile:buf owner:self withNames:NO fromZone:[self zone]];
   // sanity check
   if (!well || !window)
   {  NXLogError("problem loading BuildaDudeIIDoc.nib\n");
      return nil;
   }
  
   return self;
}

- setController:newController
{  controller = newController; 
   return self;
}

- free
{
  [controller docIsClosing:self];
  [window close];  // this will free the well nicely
  return [super free];
}

- close:sender
{
  return [self free];
}

- new:sender
{
   char buf[MAXPATHLEN + 1];
   id bundle;


   [super init];
   bundle = [NXBundle bundleForClass:[self class]];
   [bundle getPath:buf forResource:"BuildaDudeIIDoc" ofType:"nib"];
   [NXApp loadNibFile:buf owner:self withNames:NO fromZone:[self zone]];
   // sanity check
   if (!well || !window)
   {  NXLogError("problem loading BuildaDudeIIDoc.nib\n");
      return nil;
   }
  
    return self;
}

- open:sender
{
  id           theOpenPanel;
  const char   *filename;
  char         *extension, 
               *filterTypes[12] = {"eve", "rib", "mdl", "wwModel", 
                                  "mdlTemplate", "wwModelTemplate", 
                                  "cam", "wwCamera", 
                                  "scn", "wwScene", 
                                  "nib",
                                  NULL };


   [self init];
  theOpenPanel = [OpenPanel new];
  [theOpenPanel allowMultipleFiles:NO];
  if (![theOpenPanel runModalForTypes:filterTypes])
  {  return nil;
  }

  filename = [theOpenPanel filename];
  if (!filename)
  {  return nil;
  }
  extension = rindex((char *)filename, '.');
  if (!extension)
  {  return nil;
  }

  if (!strcmp(".rib", extension))
  {  [well buildNewShapeHierarchyFromRIBFile:filename];
  }
  if (!strcmp(".eve", extension))
  {  [well buildNewShapeHierarchyFromEveFile:filename];
  }
  if (!strcmp(".mdlTemplate", extension) || !strcmp(".wwModelTemplate", extension))
  {  [well readMdlTemplateFile:filename];
  }
  if (!strcmp(".mdl", extension) || !strcmp(".wwModel", extension))
  {  [well buildNewShapeHierarchyFromMdlFile:filename];
  }
  if (!strcmp(".nib", extension))
  {  [well loadNibForModelInterp:filename];
  }

   return self;
}


- import:sender
{
  id           theOpenPanel;
  const char   *filename;
  char         *extension, 
               *filterTypes[12] = {"eve", "rib", "mdl", "wwModel", 
                                  "mdlTemplate", "wwModelTemplate", 
                                  "cam", "wwCamera", 
                                  "scn", "wwScene", 
                                  "nib",
                                  NULL };


  theOpenPanel = [OpenPanel new];
  [theOpenPanel allowMultipleFiles:NO];
  if (![theOpenPanel runModalForTypes:filterTypes])
  {  return nil;
  }

  filename = [theOpenPanel filename];
  if (!filename)
  {  return nil;
  }
  extension = rindex((char *)filename, '.');
  if (!extension)
  {  return nil;
  }

  if (!strcmp(".rib", extension))
  {  [well buildNewShapeHierarchyFromRIBFile:filename];
  }
  if (!strcmp(".eve", extension))
  {  [well buildNewShapeHierarchyFromEveFile:filename];
  }
  if (!strcmp(".mdlTemplate", extension) || !strcmp(".wwModelTemplate", extension))
  {  [well readMdlTemplateFile:filename];
  }
  if (!strcmp(".mdl", extension) || !strcmp(".wwModel", extension))
  {  [well buildNewShapeHierarchyFromMdlFile:filename];
  }
  if (!strcmp(".nib", extension))
  {  [well loadNibForModelInterp:filename];
  }

   return self;
}


- save:sender
{
    return self;
}

- saveAs:sender
{
    return self;
}

- window { return window; }
- well { return well; }

- windowWillClose:sender
{
  if (sender == window)
  {  [controller docIsClosing:self];
  }

  return self;
}


///////////////////////////////
// WW3DWell delegate methods
///////////////////////////////
- wellWasUpdated:camera { return self; }
- sceneWasUpdated:camera { return self; }
- cameraParametersWereUpdated:camera { return self; }
- controlsWereUpdated:camera { return self; }


@end
