// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//

#import <appkit/appkit.h>
#import "RIBCommand.h"
#import "Protocol_WWAnimatable.h"

@interface EveCommand:Object < WWAnimatable >
{
    id myShape; // this is a pointer to the shape which has this
                // RIBCommand embedded in it.  In order to calculate it's 
                // bounding box, it needs access to the 4x4s of this shape.
    id	  interp;
    id	  eveParser;
    int   tclVarCnt;
    id    cmd;
    BOOL  hasBoundingBox;
    BOOL  isMotionBlurrable;
    BOOL  isTCLCommand;
    BOOL  isCompoundCommand;
    BOOL  pushesCTM;
    BOOL  popsCTM;

    // rendering cache stuff
    BOOL      cacheIsFilled;
    id        firstSampleData, lastSampleData; // this should be a list, but for now...

    RtFloat  lastShutterOpenTime, lastShutterCloseTime;
    id       sceneClock;
    id       samplesList;

    // boundingBox cache stuff
    RtBound    boundingBox;
    BOOL       dirtyBoundingBox;
    RtFloat    bbIntervalStart, bbIntervalEnd;

    char       *sampleName;
}

- initWithInterp:newEveInterp eveParser:newEveParser shape:newShape cmd:(char *)newCmd clock:newSceneClock frozen:(BOOL)frozenOrMalleable;
- evalAndAddAsSamples:(char *)sampleList;
- (const char *)sampleName;
- command;

@end
