// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//

// EveProcs are, to a degree, a generalization of an EveCommand.
// Whereas an EveCommand represents a single, atomic object which
// conforms to the WWRenderable protocol, an EveProc holds a *list* 
// of such objects.  Also, the eve command that is based on is
// actually an arbitrary tcl proc and its arguments.  Well, the
// tcl proc actually can't be that arbitrary: it can't have any
// calls to EveProc or EveCmd inside of it, and the only variable
// traces that will be set up for it are the ones corresponding
// the the proc's arguments - any global variables inside the 
// EveProc will not be traced.

#import "EveProc.h"
#import "WWEveParser.h"
#import "Protocol_WWSample.h"
#import "WWSampleList.h"
#import "WWSample.h"
#import "WWTCLKit.h"
//#import "WWTCLClosedCmd.h"

@implementation EveProc


- produceSampleFromCmd  {  return [eveParser evaluateEveProc:(char *)([cmd cmd])]; }

@end
