// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//


#import <appkit/appkit.h>
#import <3Dkit/3Dkit.h>

@interface WW3DCameraTemplate:Object
{
    N3DProjectionType	projectionType;	 /* perpective or orthographic */
    BOOL                projectionTypeRecorded;
    NXColor		backgroundColor; /* color of rectangle under RIB */
    BOOL                backgroundColorRecorded;
    BOOL                doesDrawBackgroundColor;
    BOOL                doesDrawBackgroundColorRecorded;
    N3DHider		hider;
    BOOL                hiderRecorded;

    float               l, r, t, b;   // projectionRectangle;
    BOOL                projectionRectangleRecorded;

    RtPoint		eyePoint, viewPoint;  /* view vector */
    BOOL                eyePointRecorded;
    BOOL                viewPointRecorded;
    float		rollAngle;  /* neg. rot. about uBasis */
    BOOL                rollAngleRecorded;
    float		fieldOfView;
    BOOL                fieldOfViewRecorded;
    float		pixelAspectRatio;
    BOOL                pixelAspectRatioRecorded;
    float		nearPlane, farPlane;
    BOOL                nearPlaneRecorded;
    BOOL                farPlaneRecorded;
    RtPoint		sBasis, tBasis, uBasis;  /* basis w.r.t. world space */
    BOOL                sBasisRecorded;
    BOOL                tBasisRecorded;
    BOOL                uBasisRecorded;
    
    RtMatrix		preTransform;	/* pre-multiply the camera matrix by
				    this matrix, if desired (cache for
				    above object) */
    BOOL                preTransformRecorded;
    BOOL                usesPreTransformMatrix;
    BOOL                usesPreTransformMatrixRecorded;
    RtMatrix		transform; /* world-to-eye transformation:
				    ct = Te . R, Te translates eye
				    point to origin, R rotates view
				    vector, V = view - eye, such
				    that it is parallel with the
				    z-axis, and rotates the resulting
				    vector about the z-axis by
				    -rollAngle. */
    BOOL                transformRecorded;
    RtFloat             fStop, focalLength, focalDistance;
    BOOL                fStopRecorded;
    BOOL                focalLengthRecorded;
    BOOL                focalDistanceRecorded;
}

- applyToCamera:aCamera;

@end
