// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//


#import <appkit/appkit.h>
#import <3Dkit/N3DLight.h>
#import "WW3DCamera.h"
#import "Protocol_WWRenderable.h"


// WAVE!! You should make this conform to the WWRenderable protocol...


@interface WW3DLight:N3DLight  < WWRenderable >
{
  List      *ribCommandList;
  id        childList;
  id        siblingList;
  unsigned 
    short   pathSeparator;
  RtFloat  visibleSizeScale, xRotate, yRotate;
  BOOL     visibleWhenPrinting;
  RtFloat   a, b, c, d, vMagnitude, cosOfAlpha, sinOfAlpha;
  RtPoint   v, u, uPrime;
  RtMatrix  xMatrix, yMatrix, zMatrix;
  RtColor   xColor, yColor,  zColor, myRtColor,
            innerConeOpacity, outerConeOpacity, beamOpacity;
  BOOL      dirtyBoundingBox, hasEveCmd;
}

- synchUpRotationValues;
- (BOOL)on;
- renderSelf:(WW3DCamera *)camera;
- makePointFrom:(RtPoint)pf intensity:(RtFloat)i;
- makeDistantFrom:(RtPoint)pf to:(RtPoint)pt intensity:(RtFloat)i;
- makeSpotFrom:(RtPoint)pf to:(RtPoint)pt
		coneAngle:(RtFloat)ca coneDelta:(RtFloat)cd
		beamDistribution:(RtFloat)bd
		intensity:(RtFloat)i;
- setFrom:(RtPoint)pf;
- setFrom:(RtPoint)pf to:(RtPoint)pt;

@end
