// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//


#import <appkit/appkit.h>
#import <3Dkit/3Dkit.h>

@interface WW3DSnapShot:Object
{
    N3DProjectionType	projectionType;	 /* perpective or orthographic */
    NXColor		backgroundColor; /* color of rectangle under RIB */
    BOOL                doesDrawBackgroundColor;
    N3DHider		hider;

    float               l, r, t, b;   // projectionRectangle;

    RtPoint		eyePoint, viewPoint;  /* view vector */
    float		rollAngle;  /* neg. rot. about uBasis */
    float		fieldOfView;
    float		pixelAspectRatio;
    float		nearPlane, farPlane;
    RtPoint		sBasis, tBasis, uBasis;  /* basis w.r.t. world space */
    
    RtMatrix		preTransform;	/* pre-multiply the camera matrix by
				    this matrix, if desired (cache for
				    above object) */
    BOOL                usesPreTransformMatrix;
    RtMatrix		transform; /* world-to-eye transformation:
				    ct = Te . R, Te translates eye
				    point to origin, R rotates view
				    vector, V = view - eye, such
				    that it is parallel with the
				    z-axis, and rotates the resulting
				    vector about the z-axis by
				    -rollAngle. */
  RtFloat    fStop, focalLength, focalDistance;
}

- applyToCamera:aCamera;

@end
