// copyright 1993 Michael B. Johnson; some portions copyright 1994, MIT
// see COPYRIGHT for reuse legalities
//

#import <appkit/appkit.h>
#import <3Dkit/3Dkit.h>

@interface WWLightInspectorCamera:N3DCamera
{
  id       theRotator;
  id       theShader;
  char     *ribName;
  NXColor  ribColor;

  id       sourceCamera;
  
  RtBound  sceneShapeBoundingBox;
  RtFloat  tesselationVector[2];
  RtFloat  lowRezTesselationVector[2];
  int      renderStyle;
  int      movingRenderStyle;

  BOOL     showSelectedShape, drawOriginForSelectedShape;

  id       image;

  float      selectionWidthEpsilon, selectionHeightEpsilon;
  int        trackballAffects;

  // avoid the stack allocation for timed entries
  NXPoint    oldMouse, newMouse, dMouse;
  RtMatrix   rmat, irmat;
  float      scaleUpFactor,
             scaleDownFactor,
             translateXFactor,
             translateYFactor,
             translateZFactor,
             epsilon;

}

+ initialize;

- initFrame:(const NXRect *)r;
- awake;
- free;

#define WW_TRACKBALL_WORLD_SHAPE    0
#define WW_TRACKBALL_CAMERA         1

- mouseDown:(NXEvent *)theEvent;
- (NXColor) backgroundColor;
- setBackgroundColor:(NXColor)c;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream; 
 
@end
