
#import <appkit/appkit.h>

@interface WWSimpleImageView:View
{
   NXColor  backgroundColor;
   float    alpha;
   id	    image;
   float    aspectRatio;
   int      aspectRatioType, borderType, horizontalLayoutType, verticalLayoutType;
   BOOL     imageUnder;
   BOOL     scaleToFit, clearTheView; 

   // control panel stuff
   id  controlPanel;
   id  controlPanelView;
   id  controlPanelSwitchView;  // optionally set by someone who wants to manage the controlPanel and View
   id  theColor;
   id  theImage;
   id  theMovie;
   id  alphaSlider;
   id  fpsText;
   id  aspectRatioMatrix;
   id  horizontalLayoutMatrix;
   id  customAspectRatioText;
   id  scaleSwitch;
   id  imageUnderSwitch;
   id  rotateTo;
   id  borderTypeMatrix;
   id  verticalLayoutMatrix;
   id  stationaryBehaviorMatrix;
   id  archiveImageDataSwitch;
   id  archiveMovieDataSwitch;
   id  loopSwitch;
   id  drawCorrectlySwitch;

}

- (NXColor) backgroundColor;
- setBackgroundColor:(NXColor)c;
- (float) alpha;
- setBackgroundAlpha:(float)n;
- setBorderType:(int)newBorderType;
- (int)borderType;
- setImageFile:(const char *)filename;
- setImage:i;
- image;
- setAspectRatioFromMatrix:sender;
- setAspectRatio:sender;
- setAspectRatioType:(int)newAspectRatioType;
- (int)aspectRatioType;
- (float)aspectRatio;
- (BOOL)imageUnder;
- setImageUnder:(BOOL)flag;
- sizeToImage:sender;
- (BOOL)scaleToFit;
- setScaleToFit:(BOOL)flag;
- setHorizontalLayoutFromMatrix:sender;
- (int)horizontalLayoutType;
- setVerticalLayoutFromMatrix:sender;
- (int)verticalLayoutType;

- (const char *)getInspectorClassName;

@end
