
#import <appkit/appkit.h>

@interface WWSimpleMovieView:View
{
   NXColor  backgroundColor;
   float    alpha;
   id	    image;
   id	    movieImage;
   float    aspectRatio;
   int      aspectRatioType, borderType, horizontalLayoutType, verticalLayoutType;
   BOOL     imageUnder;
   BOOL     imageIsShared;
   BOOL     movieIsShared;
   BOOL     scaleToFit, clearTheView; 
   float    fps, frameTimeIncr;
   BOOL     loop;
   int      stationaryBehavior;
   BOOL     sink;
   BOOL     source;
   BOOL     archiveImageData;
   BOOL     archiveMovieData;
   BOOL     drawCorrectly;

   id	    imageList;
   int      frameCount;
   int      currentFrameIndex;

   BOOL     goingForward;
   DPSTimedEntry  stationaryFrameTE;

   int      trackingRect;

   // control panel stuff
   id  controlPanel;
   id  controlPanelView;
   id  controlPanelSwitchView;  // optionally set by someone who wants to manage the controlPanel and View
   id  theColor;
   id  theImage;
   id  theMovie;
   id  alphaSlider;
   id  fpsText;
   id  aspectRatioMatrix;
   id  horizontalLayoutMatrix;
   id  customAspectRatioText;
   id  scaleSwitch;
   id  imageUnderSwitch;
   id  rotateTo;
   id  borderTypeMatrix;
   id  verticalLayoutMatrix;
   id  stationaryBehaviorMatrix;
   id  archiveImageDataSwitch;
   id  archiveMovieDataSwitch;
   id  loopSwitch;
   id  drawCorrectlySwitch;
}

- (NXColor) backgroundColor;
- setBackgroundColor:(NXColor)c;
- (float) alpha;
- setBackgroundAlpha:(float)n;
- setBorderType:(int)newBorderType;
- (int)borderType;
- setImageFile:(const char *)filename;
- setImage:i;
- image;
- movieImage;

- setImageIsShared:(BOOL)flag; 
- setMovieIsShared:(BOOL)flag; 

- setAnimDir:(const char *)filename;
- setAspectRatioFromMatrix:sender;
- setAspectRatio:sender;
- (int)aspectRatioType;
- (float)aspectRatio;
- (BOOL)imageUnder;
- setImageUnder:(BOOL)flag;
- sizeToImage:sender;
- sizeToMovie:sender; 
- removeImage:sender;
- removeMovie:sender; 
- (BOOL)scaleToFit;
- setScaleToFit:(BOOL)flag;
- setHorizontalLayoutFromMatrix:sender;
- (int)horizontalLayoutType;
- setVerticalLayoutFromMatrix:sender;
- (int)verticalLayoutType;
- (int)stationaryBehavior;
- setStationaryBehavior:(int)n;
- setStationaryBehaviorFromMatrix:sender;
- setLoop:(BOOL)n;
- (BOOL)loop;
- setArchiveImageData:(BOOL)n;
- (BOOL)archiveImageData;
- setArchiveMovieData:(BOOL)n;
- (BOOL)archiveMovieData;
- (int)frameCount;
- setFPS:(float)newFPS;
- (float)fps;
- setDrawCorrectly:(BOOL)n;
- (BOOL)drawCorrectly;

- setMyTrackingRect:(BOOL)flag;

- (const char *)getInspectorClassName;

// control panel stuff
- loadControlPanel;
- revertControlPanel:sender;
- takeColor_:sender;
- setImage_:sender;
- setMovie_:sender;
- setAlpha_:sender;
- setFPS_:sender;
- setAspectRatioFromMatrix_:sender;
- setHorizontalLayoutFromMatrix_:sender;
- setVerticalLayoutFromMatrix_:sender;
- setAspectRatio_:sender;
- setImageUnder_:sender;
- setScale_:sender;
- rotateTo_:sender;
- setBorderTypeFromMatrix_:sender;
- sizeToImage_:sender;
- sizeToMovie_:sender; 
- setStationaryBehaviorFromMatrix_:sender;
- setArchiveMovieData_:sender;
- setArchiveImageData_:sender;
- setLoop_:sender;
- setDrawCorrectly_:sender;
- saveImage:sender;
- saveMovie:sender;

@end

#define WW_PLAY_CONTINUOUS   0
#define WW_PLAY_MOUSE_CLICK  1
#define WW_PLAY_MOUSE_IN     2
