/* Copyright 1993 Michael B. Johnson
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any non-commercial 
 * purpose and without fee is hereby granted, provided that the 
 * above copyright notice appears in all copies.  Michael B. Johnson
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Permission to use, copy, modify or distribute this software
 * and its documentation for any commercial purpose must be
 * confirmed in writing with Michael B. Johnson.  He can be
 * contacted at:
 *              20 Ames St. E15-023G    
 *              Cambridge, MA 02141
 *              (617) 547 0563
 *              
 */


#import <appkit/appkit.h>
#import "tcl.h"

@interface WWTCLVarTrace:Object
{
   char              *varName;
   id                uiObject; // or datum
   id                delegate;
   id                tclInterp;
   Tcl_VarTraceProc  *traceProcPointer;
   BOOL              freeingMyself;
}

- initWithVarName:(const char *)varName proc:(Tcl_VarTraceProc *)traceProcPointer datum:(ClientData)datum delegate:delegate interp:newInterp;
- initWithVarName2:(const char *)varName :(const char *)varName2 proc:(Tcl_VarTraceProc *)traceProcPointer datum:(ClientData)datum delegate:delegate interp:newInterp;
- (BOOL)matchWithVarName:(const char *)newVarName proc:(Tcl_VarTraceProc *)newTraceProcPointer datum:(ClientData)newDatum delegate:newDelegate;

- (const char *)varName;
- tclInterp;
- datum;
- uiObject;
- (Tcl_VarTraceProc *)traceProcPointer;

- free;
- setStringValue:(const char *)newValue;
- executeTrace;
- removeTrace;

@end
