/* Copyright 1993 Michael B. Johnson
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any non-commercial 
 * purpose and without fee is hereby granted, provided that the 
 * above copyright notice appears in all copies.  Michael B. Johnson
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Permission to use, copy, modify or distribute this software
 * and its documentation for any commercial purpose must be
 * confirmed in writing with Michael B. Johnson.  He can be
 * contacted at:
 *              20 Ames St. E15-023G    
 *              Cambridge, MA 02141
 *              (617) 547 0563
 *              
 */

#include "WWTCLWidgetsPalette.h"
#include "WWThumbWheel.h"
#include "WWButton.h"
#include "WWSimpleMovieView.h"

@implementation  WWTCLWidgetsPalette

- finishInstantiate
{
  [self associateObject:tclInterpData type:IBObjectPboardType with:tclInterpView];
  [self associateObject:timerData type:IBObjectPboardType with:timerView];
  return self;
}

- setLinHorizTW:object { linHorizTW=object; return self; }

- setLinVertTW:object 
{ linVertTW = object; [linVertTW setDirection:DIRECTION_VERTICAL];return self;}

- setRadHorizTW:object
{
	radHorizTW=object;
	[radHorizTW setDisplayMode:DISPLAY_MODE_RADIAL];
	[radHorizTW setVisibleMax:90];  [radHorizTW setVisibleMin:-90];
	[radHorizTW setAbsoluteMax:90]; [radHorizTW setAbsoluteMin:-90];
	return self;
}

- setRadVertTW:object
{
	radVertTW=object;
	[radVertTW setDirection:DIRECTION_VERTICAL]; 
	[radVertTW setDisplayMode:DISPLAY_MODE_RADIAL];
	[radVertTW setVisibleMax:90];  [radVertTW setVisibleMin:-90];
	[radVertTW setAbsoluteMax:90]; [radVertTW setAbsoluteMin:-90];
	return self;
}

- setSwitchButton:object
{
  switchButton=object;
  [switchButton setTitle:"Switch"]; 
  [switchButton setIcon:"NXswitch" position:NX_ICONRIGHT];
  [switchButton setAltIcon:"NXswitchH"];
  [switchButton setType:NX_SWITCH];
  return self;
}

- setTextField:object
{
  textField=object;
  [textField setStringValue:"Text"]; 
  [textField setBezeled:YES];
  [textField setEditable:YES];
  return self;
}

- setMovieVarView:object
{
  movieVarView=object;
  // this image should be in the palette bundle...
  [movieVarView setImageFile:"WWMovieVarView"]; 
  [movieVarView setImageIsShared:YES]; 
  return self;
}

- setMovieProcView:object
{
  movieProcView=object;
  // this image should be in the palette bundle...
  [movieProcView setImageFile:"WWMovieProcView"]; 
  [movieProcView setImageIsShared:YES]; 
  return self;
}


- setMovieView:object
{
  movieView=object;
  // this image should be in the palette bundle...
  [movieView setImageFile:"WWSimpleMovieView"]; 
  [movieView setImageIsShared:YES]; 
  // should have an anim here too...

  return self;
}


@end
