/* SwitchView.h
 * Written By:  Thomas Burkholder
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 */

// hacked a bit by wave to fix some bugs (and incorporate bug fixes from NeXT)...
// name space protected for WavesWorld by the addition of the "WWTT" prefix


#import <appkit/appkit.h>

// A Box subclass that can swap views in and out of it's content view
@interface WWTTSwitchView:Box
{
	id	(views);           // list of views to be shown
	SEL	valueSelector;     // callback method to control
	int	initialViewNumber; // number of the first view to show
	int currentViewNumber;
}

- initFrame:(const NXRect *)frameRect;
- free;
- views;

- setViewNumber:(int)ndx;

// action method to use to swap in a view
- takeViewNumberFrom:sender;
- takeTagFrom:sender;
- takeIntValueFrom:sender;
- takeSelectedRowFrom:sender;
- takeSelectedColFrom:sender;

- setValueSelector:(SEL)aSelector;  // use to set the callback
- (SEL)valueSelector;
- setInitialViewNumber:(int)num;
- (int)initialViewNumber;
- (SEL)guessValueSelectorForSwitchSource:sender;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
