/* SwitchViewConnectInspector.h
 * Written By:  Thomas Burkholder
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 */

#import <appkit/appkit.h>
#import <apps/InterfaceBuilder.h>
#import "WWTTSwitchView.h"

// name space protected for WavesWorld by the addition of the "WWTT" prefix

// Category of SwitchView that does the connections-specific stuff
@interface WWTTSwitchView (ConnectionsInspector)

-(const char *)getConnectInspectorClassName;

@end

// Connection inspector for the SwitchView class
@interface WWTTSwitchViewConnectInspector:IBInspector
{
	id browser;          // The matrix of ButtonCells showing object class
	id connectButton;    // The connect/disconnect button.
	id connectorList;    // The list of connectors that we show
}

- init;
- selectConnection:sender;  // action of the matrix
- ok:sender;
- revert:sender;
- (BOOL)wantsButtons;

@end
