/* TimerInspector.h
 * Written By:  Thomas Burkholder
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 */

#import <appkit/appkit.h>
#import <apps/InterfaceBuilder.h>
#import "WWTTTimer.h"

// Category of Timer that does the inspector-specific stuff
@interface WWTTTimer (AttributesInspector)

- (const char *)getInspectorClassName;
- (NXImage *)getIBImage;

@end

// Inspector for the WWTTTimer class
@interface WWTTTimerIBInspector:IBInspector
{
	id	autoStartSwitch;	// field for auto-starting
	id	periodField;		// field for period entry/display
	id	priorityField;		// field for priority entry/display
	id	visibleDebugSwitch;	// switch for visibleDebug mode on/off

	id	behaviorMatrix;			// switch for wrap & lifespan type
	id	behaviorText;			// info for wrap & lifespan type
	id	behaviorValueField;		// field for wrapValue entry/display

	id	syncSwitch;			// switch for synchronization on/off
	id	syncValueField;		// field for synchronization entry/display
	id	startValueField;		// field for startValue entry/display
	id	incrementByField;		// field for incrementBy entry/display

  char  *preControlString;
  int   preControlStringSize;
  id	preControlStringText;
  id	preControlScrollView;

  char  *conditional;
  int   conditionalSize;
  id	conditionalText;
  id	conditionalScrollView;

  char  *controlString;
  int   controlStringSize;
  id	theControlStringText;
  id	theControlScrollView;

  char  *postControlString;
  int   postControlStringSize;
  id	postControlStringText;
  id	postControlScrollView;
}

- init;
- (BOOL)wantsButtons;
- thresholdPopped:sender;	// action for the threshold PopUpList
- setBehavior:sender; // action for the behaviorMatrix
- revertInspector:sender;

@end
